;===========================================================================================
; Menu_2Fr.asm  Fasm Flat assembler
; Base d'application
; Programm par AsmGges France
;===========================================================================================

format PE GUI 4.0
entry start

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  include 'win32a.inc'
  include 'macro\if.inc'

;===========================================================================================
; Dbut du code programme
; -----------------------
section '.code' code readable executable

start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne
    ; ----------------------
    invoke LoadIcon,[wc.hInstance],IDI_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur
    ; -----------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Chargement d'un menu
    ; --------------------
    invoke LoadMenu,[wc.hInstance],IDM_MENU
    mov [hMenu],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Obtenir la hauteur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CYSCREEN
    sub eax,[WinH]
    shr eax,1
    mov [WinY],eax

    ; Valider le choix de la structure WNDCLASS
    ; -----------------------------------------
    invoke RegisterClass,wc

    ; Cration de la fentre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,ClassName,Title,WS_OVERLAPPEDWINDOW+WS_VISIBLE,\
                          [WinX],[WinY],[WinW],[WinH],0,[hMenu],[wc.hInstance],0
    mov [hWnd],eax

    ; Affichage de la fentre
    ; -----------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT

    ; Rafraichissement de la fentre
    ; ------------------------------
    invoke UpdateWindow,[hWnd]

 ;----------------------------------
 ; Boucle de traitement des messages
 ;----------------------------------
 MessageLoop:
    ; Rceptionne les messages
    ; ------------------------
    invoke GetMessage,msg,0,0,0
    or eax,eax
    jz ExitProgram

    ; Traduit les touches d'entre clavier en messages
    ; ------------------------------------------------
    invoke TranslateMessage,msg

    ; Expdition des messages  la procdure Windows
    ; ---------------------------------------------
    invoke DispatchMessage,msg

    jmp MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
proc WindowProc uses ebx esi edi, @hWnd, @uMsg, @wParam, @lParam

    .if [@uMsg] = WM_CLOSE
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],MsgEnd,ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande la fin de l'application
        ; -------------------------------
        invoke PostQuitMessage,0

    .elseif [@uMsg] = WM_COMMAND
        mov  eax,[@wParam]
        .if eax = IDM_NOUVEAU             ;sub menu 1_1
            ;
        .elseif eax = IDM_OUVRIR          ;sub menu 1_2
            ;
        .elseif eax = IDM_SAUVER          ;sub menu 1_3
            ;
        .elseif eax = IDM_SAUVERSOUS      ;sub menu 1_4
            ;
        .elseif eax = IDM_QUITTER         ;sub menu 1_5
            ; Boite  message sous menu 1_5
            ; -----------------------------
            invoke MessageBox,[@hWnd],MsgBoxSM1_3,ClassName,MB_OK+MB_ICONINFORMATION

            ; Demande la fin de l'application
            ; -------------------------------
            invoke PostQuitMessage,0

        .elseif eax = IDM_ANNULER         ;sub menu 2_1
            ;
        .elseif eax = IDM_COUPER          ;sub menu 2_2
            ;
        .elseif eax = IDM_COPIER          ;sub menu 2_3
            ;
        .elseif eax = IDM_COLLER          ;sub menu 2_4
            ;
        .elseif eax = IDM_EFFACER         ;sub menu 2_5
            ;
        .elseif eax = IDM_SELECTIONT      ;sub menu 2_6
            ;
        .elseif eax = IDM_LISEZMOI        ;sub menu 3_1
            ;
        .elseif eax = IDM_APROPOS         ;sub menu 3_2
            ;
        .endif

        ; Boite  message
        ; ---------------
        invoke MessageBox,[@hWnd],MsgBox,ClassName,MB_OK+MB_ICONINFORMATION

    .else
        ; Traitement par dfaut des autres messages Windows
        ; -------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .endif

    mov eax,0
    ret
endp

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
section '.data' data readable writeable

  Title       db " Base d'application",0
  ClassName   db ' AsmGges Win32',0
  MsgEnd      db ' AsmGges France @2006  ',0
  MsgBox      db " Base d'application",13,10
              db 'AsmGges France @2006',0
  MsgBoxSM1_3 db 'Fin de programme !',0
  align 4

  WinX        dd 0
  WinY        dd 0
  WinW        dd 512
  WinH        dd 352

  hWnd        dd ?
  hMenu       dd ?
  wc          WNDCLASS  0,WindowProc,0,0,NULL,NULL,NULL,COLOR_WINDOW+1,NULL,ClassName
  msg         MSG

;===========================================================================================
; Inclusion des fichiers .dll contenant les fonctions Windows utilises
;-------------------------------------------------------------------------------------------
section '.idata' import data readable writeable

  library kernel32,'KERNEL32.DLL',\
            user32,'USER32.DLL'

  ; Apis Windows dans fichiers dlls
  ; -------------------------------
  include 'apia\kernel32.inc'
  include 'apia\user32.inc'

;===========================================================================================
; Inclusion des icnes / curseurs / bitmap
;-------------------------------------------------------------------------------------------
section '.rsrc' resource data readable

  directory RT_MENU,menus,\
            RT_ICON,icons,\
            RT_GROUP_ICON,group_icons

  IDI_FRANCE = 17

  resource menus,\
           IDM_MENU,LANG_ENGLISH+SUBLANG_DEFAULT,main_menu

  resource icons,\
           1,LANG_NEUTRAL,icon_data

  resource group_icons,\
           IDI_FRANCE,LANG_NEUTRAL,main_icon

 IDM_MENU       = 37

 IDM_FICHIER    = 100          ;menu 1
 IDM_NOUVEAU    = 101          ;sub menu 1_1
 IDM_OUVRIR     = 102          ;sub menu 1_2
 IDM_SAUVER     = 103          ;sub menu 1_3
 IDM_SAUVERSOUS = 104          ;sub menu 1_4
 IDM_QUITTER    = 105          ;sub menu 1_5

 IDM_EDITION    = 200          ;menu 2
 IDM_ANNULER    = 201          ;sub menu 2_1
 IDM_COUPER     = 202          ;sub menu 2_2
 IDM_COPIER     = 203          ;sub menu 2_3
 IDM_COLLER     = 204          ;sub menu 2_4
 IDM_EFFACER    = 205          ;sub menu 2_5
 IDM_SELECTIONT = 206          ;sub menu 2_6

 IDM_AIDE       = 300          ;menu 3
 IDM_LISEZMOI   = 301          ;sub menu 3_1
 IDM_APROPOS    = 302          ;sub menu 3_2

 _ equ ,09h,                   ;tab

  menu main_menu
       menuitem '&Fichier',IDM_FICHIER,MFR_POPUP
                menuitem '&Nouveau' _ 'Ctrl+N',IDM_NOUVEAU
                menuitem '&Ouvrir' _ 'Ctrl+O',IDM_OUVRIR
                menuitem '&Sauver' _ 'Ctrl+S',IDM_SAUVER
                menuseparator
                menuitem 'S&auver Sous...',IDM_SAUVERSOUS
                menuseparator
                menuitem '&Quitter' _ 'Alt+Q',IDM_QUITTER,MFR_END

       menuitem '&Edition',IDM_EDITION,MFR_POPUP
                menuitem '&Annuler'  _ 'Ctrl+Z',IDM_ANNULER
                menuseparator
                menuitem '&Couper' _ 'Ctrl+X',IDM_COUPER
                menuitem 'Co&pier' _ 'Ctrl+C',IDM_COPIER
                menuitem 'C&oller' _ 'Ctrl+V',IDM_COLLER
                menuitem '&Effacer' _ 'Del',IDM_EFFACER
                menuseparator
                menuitem 'Selectionner &Tout',IDM_SELECTIONT,MFR_END

       menuitem '&Aide',IDM_AIDE,MFR_POPUP + MFR_END
                menuitem '&Lisez-moi',IDM_LISEZMOI
                menuitem '&A propos..',IDM_APROPOS,MFR_END

  icon main_icon,icon_data,'res\france.ico'

;===========================================================================================
